import{ world, MinecraftBlockTypes, system, BlockLocation, EntityTypes  } from "@minecraft/server";
import { questList } from "./data/quest_list"
import { guildShopList } from "./data/guild_shop_list"

//this function is for future compatibility :)
if(EntityTypes.get("aq:quest_loader")){
	var loopId = system.runSchedule(() => {
		if(Array.from(world.getPlayers())[0].location){
			let playerLoc = Array.from(world.getPlayers())[0].location;
			let spawnLoc = new BlockLocation(playerLoc.x, playerLoc.y, playerLoc.z);
			let summon_quest_list = world.getDimension("minecraft:overworld").spawnEntity("aq:quest_loader", spawnLoc);
			console.warn("load " + questList.quest.length + " quest and " + guildShopList.list.length + " shop item");
			summon_quest_list.addTag(JSON.stringify(questList));
			summon_quest_list.addTag(JSON.stringify(guildShopList));
			summon_quest_list.addTag("load_quest");
			summon_quest_list.triggerEvent("load_quest");
			system.clearRunSchedule(loopId);
		}
	});
}else{
	console.warn("please use adverure quest addon to load quests");
}

const tall_door_list = [ 
	"kd:acacia_tall_door_item", 
	"kd:bamboo_tall_door_item", 
	"kd:birch_tall_door_item", 
	"kd:crimson_tall_door_item", 
	"kd:dark_oak_tall_door_item", 
	"kd:jungle_tall_door_item", 
	"kd:mangrove_tall_door_item", 
	"kd:oak_tall_door_item", 
	"kd:quartz_tall_door_item", 
	"kd:quartz_door_item", 
	"kd:spruce_tall_door_item", 
	"kd:stone_tall_door_item", 
	"kd:stone_door_item", 
	"kd:warped_tall_door_item", 
	"kd:iron_bars_tall_door_item", 
	"kd:door_template_item"
]

const door_list = [ 
	"kd:acacia_chiseled_door_item", 
	"kd:bamboo_chiseled_door_item", 
	"kd:birch_chiseled_door_item", 
	"kd:crimson_chiseled_door_item", 
	"kd:dark_oak_chiseled_door_item", 
	"kd:jungle_chiseled_door_item", 
	"kd:mangrove_chiseled_door_item", 
	"kd:oak_chiseled_door_item", 
	"kd:iron_bars_chiseled_door_item", 
	"kd:iron_bars_door_item", 
	"kd:quartz_chiseled_door_item", 
	"kd:quartz_door_item", 
	"kd:spruce_chiseled_door_item", 
	"kd:stone_chiseled_door_item", 
	"kd:stone_door_item", 
	"kd:warped_chiseled_door_item", 
	"kd:door_template_item"
]

world.events.beforeItemUseOn.subscribe(s => {
	if(door_list.includes(s.item.typeId) && s.blockFace == "up"){
		let block_scan = s.blockLocation;
		block_scan.y += 2;
		s.cancel = s.source.dimension.getBlock(block_scan).typeId != "minecraft:air";
	}
	if(tall_door_list.includes(s.item.typeId) && s.blockFace == "up"){
		let block_scan = s.blockLocation;
		let block_scan_top = s.blockLocation;
		block_scan_top.y += 3;
		block_scan.y += 2;
		s.cancel = s.source.dimension.getBlock(block_scan).typeId != "minecraft:air" || s.source.dimension.getBlock(block_scan_top).typeId != "minecraft:air";
	}
});

world.events.blockBreak.subscribe(s => {
	if(s.brokenBlockPermutation.getProperty("door:top") && s.brokenBlockPermutation.getProperty("door:top").value){
		let block_scan = s.block.location;
		block_scan.y -= 1;
		s.block.dimension.getBlock(block_scan).setType(MinecraftBlockTypes.air);
	}
});